/**
 * Database Migration API
 * Use the Oracle Cloud Infrastructure Database Migration APIs to perform database migration operations.
 * OpenAPI spec version: 20210929
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * AWS S3 bucket details used for source Connection resources with RDS_ORACLE type.
 * Only supported for source Connection resources with RDS_ORACLE type.
 *
 */
export interface AwsS3Details {
    /**
     * S3 bucket name.
     *
     */
    "name": string;
    /**
     * AWS region code where the S3 bucket is located.
     * Region code should match the documented available regions:
     * https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/using-regions-availability-zones.html#concepts-available-regions
     *
     */
    "region": string;
}
export declare namespace AwsS3Details {
    function getJsonObj(obj: AwsS3Details): object;
    function getDeserializedJsonObj(obj: AwsS3Details): object;
}
