"use strict";
/**
 * Network Firewall API
 * Use the Network Firewall API to create network firewalls and configure policies that regulates network traffic in and across VCNs.
 * OpenAPI spec version: 20211001
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NetworkFirewallPolicy = void 0;
const model = __importStar(require("../model"));
const common = require("oci-common");
var NetworkFirewallPolicy;
(function (NetworkFirewallPolicy) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "mappedSecrets": obj.mappedSecrets
                ? common.mapContainer(obj.mappedSecrets, model.MappedSecret.getJsonObj)
                : undefined,
            "securityRules": obj.securityRules
                ? obj.securityRules.map(item => {
                    return model.SecurityRule.getJsonObj(item);
                })
                : undefined,
            "decryptionRules": obj.decryptionRules
                ? obj.decryptionRules.map(item => {
                    return model.DecryptionRule.getJsonObj(item);
                })
                : undefined,
            "decryptionProfiles": obj.decryptionProfiles
                ? common.mapContainer(obj.decryptionProfiles, model.DecryptionProfile.getJsonObj)
                : undefined
        });
        return jsonObj;
    }
    NetworkFirewallPolicy.getJsonObj = getJsonObj;
    function getDeserializedJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "mappedSecrets": obj.mappedSecrets
                ? common.mapContainer(obj.mappedSecrets, model.MappedSecret.getDeserializedJsonObj)
                : undefined,
            "securityRules": obj.securityRules
                ? obj.securityRules.map(item => {
                    return model.SecurityRule.getDeserializedJsonObj(item);
                })
                : undefined,
            "decryptionRules": obj.decryptionRules
                ? obj.decryptionRules.map(item => {
                    return model.DecryptionRule.getDeserializedJsonObj(item);
                })
                : undefined,
            "decryptionProfiles": obj.decryptionProfiles
                ? common.mapContainer(obj.decryptionProfiles, model.DecryptionProfile.getDeserializedJsonObj)
                : undefined
        });
        return jsonObj;
    }
    NetworkFirewallPolicy.getDeserializedJsonObj = getDeserializedJsonObj;
})(NetworkFirewallPolicy = exports.NetworkFirewallPolicy || (exports.NetworkFirewallPolicy = {}));
//# sourceMappingURL=network-firewall-policy.js.map