/**
 * Stack Monitoring API
 * Stack Monitoring API.
 * OpenAPI spec version: 20210330
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The information about new monitored resource. The combination of monitored resource name and type should be unique across tenancy.
 */
export interface CreateMonitoredResourceDetails {
    /**
     * Monitored resource name
     */
    "name": string;
    /**
     * Monitored resource display name.
     */
    "displayName"?: string;
    /**
     * Monitored resource type
     */
    "type": string;
    /**
     * Compartment Identifier [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm)
     */
    "compartmentId": string;
    /**
     * Host name of the monitored resource
     */
    "hostName"?: string;
    /**
     * Management Agent Identifier [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm).
     */
    "managementAgentId"?: string;
    /**
     * Time zone in the form of tz database canonical zone ID.
     */
    "resourceTimeZone"?: string;
    /**
     * List of monitored resource properties
     */
    "properties"?: Array<model.MonitoredResourceProperty>;
    "databaseConnectionDetails"?: model.ConnectionDetails;
    "credentials"?: model.PreExistingCredentials | model.EncryptedCredentials | model.PlainTextCredentials;
    "aliases"?: model.MonitoredResourceAliasCredential;
}
export declare namespace CreateMonitoredResourceDetails {
    function getJsonObj(obj: CreateMonitoredResourceDetails): object;
    function getDeserializedJsonObj(obj: CreateMonitoredResourceDetails): object;
}
